/* YAMAMOTO IS DEAD */

#define _CRT_SECURE_NO_DEPRECATE 1
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
#include <Windows.h>
#include <guiddef.h>
#define PATH_SEPARATOR '\\'

#else 
typedef struct _GUID {
    unsigned long  Data1;
    unsigned short Data2;
    unsigned short Data3;
    unsigned char  Data4[ 8 ];
} GUID;
typedef unsigned long DWORD;
typedef unsigned int UINT;

#define sprintf_s snprintf
#define _strdup strdup
#define PATH_SEPARATOR '/'
#endif

const char * reward_types[] = {
		"UNKNOWN",
		"CERTIFICATE",
		"TROPHY",
		"MEDAL",
		"BADGE",
		"SPECIAL_ITEM",
		"POSTCARD"
};

const char * hours_types[] = {
		"UNKNOWN",
		"ANY",
		"VFR",
		"IFR",
		"DAY",
		"NIGHT",
		"SAILPLANE",
		"LANDPLANE",
		"SEAPLANE",
		"ROTORCRAFT",
		"MULTI_ENGINE"
};

typedef struct reward_hdr {
	DWORD total_size;
	DWORD first_ptr;
	DWORD file_id;
	DWORD version;
	DWORD nrewards;
} reward_hdr_t;


const int key1[] = {
	 0x03 , 0xb0 , 0x3b , 0x70 , 0xcd , 0x81 , 0xdb , 0x06,  
	 0x6c , 0x0e , 0xe0 , 0x33 , 0x60 , 0xb7 , 0x01 , 0x9b, 
	 0x1d , 0xb8 , 0x0c , 0xc0 , 0xed , 0xc0 , 0x36 , 0x07,
	 0x6e , 0x19 , 0xb0 , 0x3b , 0x80 , 0xcd , 0x81 , 0xdc, 
	 0x06 , 0x6c , 0x76 , 0xe0 , 0x33 , 0x03 , 0xb7 , 0x01,
	 0xd8 , 0x1d , 0xb8 , 0x66 , 0xc0 , 0xed , 0x03 , 0x36, 
	 0x07 , 0x70 , 0x19 , 0xb0 , 0xdb , 0x80 , 0xcd , 0x0e,
	 0xdc , 0x06 , 0x60 , 0x76 , 0xe0 , 0x9b , 0x03 , 0xb7, 
	 0x0c , 0xd8 , 0x1d , 0xc0 , 0x66 , 0xc0 , 0x6e , 0x03,
	 0x36 , 0x3b , 0x70 , 0x19 , 0x81 , 0xdb , 0x80 , 0x6c,  
	 0x0e , 0xdc , 0x33 , 0x60 , 0x76 , 0x01 , 0x9b , 0x03,
	 0xb8 , 0x0c , 0xd8 , 0xed , 0xc0 , 0x66 , 0x07 , 0x6e
};

const int key2[] = {
	 0x19 , 0xb0 , 0x3b , 0x80 , 0xcd , 0x81 , 0xdc , 0x06,  
	 0x6c , 0x76 , 0xe0 , 0x33 , 0x03 , 0xb7 , 0x01 , 0xd8, 
	 0x1d , 0xb8 , 0x66 , 0xc0 , 0xed , 0x03 , 0x36 , 0x07,
	 0x70 , 0x19 , 0xb0 , 0xdb , 0x80 , 0xcd , 0x0e , 0xdc, 
	 0x06 , 0x60 , 0x76 , 0xe0 , 0x9b , 0x03 , 0xb7 , 0x0c,
	 0xd8 , 0x1d , 0xc0 , 0x66 , 0xc0 , 0x6e , 0x03 , 0x36, 
	 0x3b , 0x70 , 0x19 , 0x81 , 0xdb , 0x80 , 0x6c , 0x0e,
	 0xdc , 0x33 , 0x60 , 0x76 , 0x01 , 0x9b , 0x03 , 0xb8, 
	 0x0c , 0xd8 , 0xed , 0xc0 , 0x66 , 0x07 , 0x6e , 0x03,
	 0xb0 , 0x3b , 0x70 , 0xcd , 0x81 , 0xdb , 0x06 , 0x6c,  
	 0x0e , 0xe0 , 0x33 , 0x60 , 0xb7 , 0x01 , 0x9b , 0x1d,
	 0xb8 , 0x0c , 0xc0 , 0xed , 0xc0 , 0x36 , 0x07 , 0x6e
};

#define KEY_LEN 96

static void decode(char *buf, UINT len, const int *key)
{
	UINT i;
	buf[0] = buf[0] ^ (key[0] + 22);
	for (i = 1; i < len; i++) {
		buf[i] = buf[i] ^ key[i % KEY_LEN];
	}
}

static void decode2(char *buf, UINT len, const int *key)
{
	UINT i;
	for (i = 0; i < len; i++) {
		buf[i] = buf[i] ^ key[i % KEY_LEN];
	}
}

static int decode_pos(int ch, int pos, const int *key) 
{
	if (pos == 0) 
		return (ch ^ (key[0] + 22)) & 0xff;

	return (ch ^ key[pos % KEY_LEN]) & 0xff;
}


static char *parse_name(FILE *fp, int type, int size)
{
	char *buf;
	buf = (char *) malloc(size - 4+1);
	if (fread(buf, 1, size-4, fp) != (size - 4)) {
		perror("short read");
		exit(-1);
	}
	decode(buf, size-4, key1);
	buf[size-4] = '\0';
	return buf;
}

static int parse_file(FILE *fp, char *output_dir, char *output_basename, UINT size)
{
	static int file_count = 0;
	char outfilename[512];
	FILE *outfilep;
	UINT nt = 0;
	int c = 0;

	sprintf_s(outfilename, 512, "%s%c%s-%d.jpg", output_dir, 
		PATH_SEPARATOR, output_basename, file_count++);
	outfilep = fopen(outfilename, "wb");
	if (outfilep == NULL) {
		perror("fopen");
		exit(-1);
	}

	while (nt < (size - 4)) {
		c = fgetc(fp);
		c = decode_pos(c, nt, key1);
		fputc(c, outfilep);
		nt++;
	}

	fflush(outfilep);
	fclose(outfilep);
	return file_count - 1;

}

static void parse_criteria(FILE *fp, FILE *xmlfp, int type, UINT size)
{
	DWORD crit;
	char *buffer;
	UINT i;
	char ICAO_buf[5];
	float *hour;
	GUID *guid;

	if (type == 0x05) {
		fprintf(xmlfp, "\n\t\t<Criteria");
		fread(&crit, 4, 1, fp);
		decode2((char*) &crit, 4, key2);
		if (crit & 0xffff) 
			fprintf(xmlfp, "\n\t\t\tlandings=\"%lu\"", crit & 0xffff);

		if (crit >> 16)
			fprintf(xmlfp, "\n\t\t\tdifferentAirports=\"%lu\"", crit >> 16);
		fprintf(xmlfp, ">");
	}

	if (type == 0x06) {
		buffer = (char *)malloc(size - 4);
		fread(buffer, size - 4, 1, fp);
		decode2(buffer, size - 4, key2);
		for (i = 4; i < (size - 4); i += 4) {
			memset(ICAO_buf, 0, 5);
			memcpy(ICAO_buf, &buffer[i], 4);
			fprintf(xmlfp, "\n\t\t\t<RewardAirport ident=\"%s\"/>", ICAO_buf);
		}
		fflush(stdout);	
		free(buffer);
	}
	if (type == 0x07) {
		buffer = (char *)malloc(size - 4);
		fread(buffer, size - 4, 1, fp);
		decode2(buffer, size - 4, key2);
		for (i = 4; i < (size - 4); i += 16) {
			guid = (GUID *) &buffer[i];
			fprintf(xmlfp, "\n\t\t\t<DependantRewardId "
				"rewardId=\"{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}\"/>",
				guid->Data1, guid->Data2, guid->Data3, 
				guid->Data4[0], guid->Data4[1], guid->Data4[2], guid->Data4[3],
				guid->Data4[4], guid->Data4[5], guid->Data4[6], guid->Data4[7]);
		}
		fflush(stdout);	
		free(buffer);

	}

	if (type == 0x08) {
		buffer = (char *)malloc(size - 4);
		fread(buffer, size - 4, 1, fp);
		decode2(buffer, size - 4, key2);
		for (i = 4; i < (size - 4); i += 5) {
			hour = (float *) &buffer[i+1];
			fprintf(xmlfp, "\n\t\t\t<RewardHours hours=\"%f\" hoursType=\"%s\"/>", *hour, hours_types[(int)buffer[i]]);
		}
		fflush(stdout);	
		free(buffer);
	}
	
}

static void parse_reward(FILE *fp, FILE *xmlfp, char *output_dir, char *output_basename)
{
	char buffer[20];
	GUID *guid;
	int *rew_type;
	DWORD entryhdr;
	long end_of_reward;
	int reward_item_closed = 0;
	int criteria_item_closed = 1;

	fread(&entryhdr, 4, 1, fp);
	end_of_reward = ftell(fp) + (entryhdr >> 8) - 4;
	entryhdr &= 0xff;

	if (entryhdr != 0x1) {
		fprintf(stderr, "Non reward entry at %ld\n", ftell(fp));
		return;
	}

	fread(buffer, 1, 20, fp);
	decode2(buffer, 20, key2);
	rew_type = (int *) buffer;
	guid = (GUID *)(buffer + 4);

	fprintf(xmlfp, "\t<Reward\n"
		"\t\trewardId=\"{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}\"\n"
		"\t\ttype=\"%s\"", guid->Data1, guid->Data2, guid->Data3, 
		guid->Data4[0], guid->Data4[1], guid->Data4[2], guid->Data4[3],
		guid->Data4[4], guid->Data4[5], guid->Data4[6], guid->Data4[7],
		reward_types[*rew_type]);

	while (ftell(fp) < end_of_reward) {
		fread(&entryhdr, 4, 1, fp);

		switch (entryhdr & 0xff) {
			case 0x02:
			case 0x03: {
				char *name = parse_name(fp, entryhdr & 0xff, entryhdr >> 8);
				if ((entryhdr & 0xff) == 0x2) 
					fprintf(xmlfp, "\n\t\tname=\"%s\"", name);
				else
					fprintf(xmlfp, "\n\t\tdescription=\"%s\"", name);
				free(name);
				break;
					   }
			case 0x04:
			case 0x0A:
			case 0x09:
				{
				int fileno = parse_file(fp, output_dir, output_basename, entryhdr >> 8);

				if ((entryhdr & 0xff) == 0x04)
					fprintf(xmlfp, "\n\t\tbitmap=\"%s-%d.jpg\"", output_basename, fileno);
				else if ((entryhdr & 0xff) == 0x9) 
					fprintf(xmlfp, "\n\t\trewardDetailDescription=\"%s-%d.jpg\"", output_basename, fileno);
				else if ((entryhdr & 0xff) == 0xA) 
					fprintf(xmlfp, "\n\t\trewardDetailBitmap=\"%s-%d.jpg\"", output_basename, fileno);
				break;
				}
			case 0x05:
			case 0x06:
			case 0x07:
			case 0x08:
				if (!reward_item_closed) {
					fprintf(xmlfp, ">");
					reward_item_closed = 1;
				}
				parse_criteria(fp, xmlfp, entryhdr & 0xff, entryhdr >> 8);
				criteria_item_closed = 0;
				break;
			default:
				fprintf(stderr, "Unknown entry type; %lu @ %ld (EOR %ld)\n", entryhdr & 0xff, ftell(fp), end_of_reward);
				fflush(stderr);
		}
	}
	if (!reward_item_closed) {
		fprintf(xmlfp, ">");
		reward_item_closed = 1;
	}
	if (!criteria_item_closed) {
		fprintf(xmlfp, "\n\t\t</Criteria>");
	}

	fprintf(xmlfp, "\n\t</Reward>\n");
	fflush(xmlfp);
}

void extract_path(char *path)
{
	size_t i;
	for (i = strlen(path) - 1; i > 0; i--) {
		if (path[i] == '\\' ||path[i] == '/') {
			path[i+1] = '\0';
			return;
		}
	}
	*path='\0';
}

char *extract_file_base(char *path)
{
	char *bs = NULL;
	size_t i;
	char *lastpt;

	for (i = strlen(path) - 1; i > 0; i--) {
		if (path[i] == '\\' ||path[i] == '/') {
			bs = &path[i+1];
			break;
		}
	}
	if (!bs) bs = path;
	
	lastpt = strstr(bs, ".RWD");
	if (lastpt != NULL) *lastpt = '\0';
	lastpt = strstr(bs, ".rwd");
	if (lastpt != NULL) *lastpt = '\0';
	
	return bs;
}

int main(int argc, char* argv[])
{
	char *input_file;
	char *output_dir = NULL;
	char *output_base_name = NULL;
	char *output_file = NULL;
	FILE *fp = NULL;
	FILE *xmlfp = NULL;
	reward_hdr_t hdr;
	UINT i;
	char *lastpt;
	long current_pos;
	DWORD reward_offset;
	
	if (argc < 2) {
		fprintf(stderr, "Usage: %s <input.rwd> [output_dir]\n", argv[0]);
		return -1;
	}

	// input
	input_file = argv[1];
	fp = fopen(input_file, "rb");
	if (fp == NULL) {
		perror("fopen");
		return -1;
	}
	fread(&hdr, sizeof(reward_hdr_t), 1, fp);

	// output
	if (argc > 2) {
		output_dir = argv[2];
	} else {
		output_dir = _strdup(input_file);
		extract_path(output_dir);
	}

	output_file = _strdup(input_file);
	lastpt = strstr(output_file, ".RWD");
	if (lastpt != NULL) strcpy(lastpt, ".XML");
	lastpt = strstr(output_file, ".rwd");
	if (lastpt != NULL) strcpy(lastpt, ".xml");
	xmlfp = fopen(output_file, "w");
	if (xmlfp == NULL) {
		perror("fopen");
		xmlfp = stdout;
	} else {
		fprintf(stderr, "Writing output to %s\n", output_file);
		fflush(stderr);
	}
	
	output_base_name = extract_file_base(input_file);

	fprintf(xmlfp, "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>\n");
	fprintf(xmlfp, "<FSData version=\"9.0\">\n");

	for (i = 0; i < hdr.nrewards; i++) {
		fread(&reward_offset, sizeof(reward_offset), 1, fp);
		current_pos = ftell(fp);
		fseek(fp, reward_offset, SEEK_SET);
		parse_reward(fp, xmlfp, output_dir, output_base_name);
		fflush(stdout);
		fseek(fp, current_pos, SEEK_SET);
	}

	fprintf(xmlfp, "</FSData>");
	fclose(fp);
	return 0;
}

